# Éléments par Codeblocks
## Consignes
L'objectif donné à Codeblocks pour cette édition spéciale était de
faire un "Tableau périodique", ce qu'il a fait. La description indique
qu'il est possible de sélectionner un élément pour avoir des informations
dessus.

Le g1m contient davantage qu'un programme et ses pictures, il contient quatre
autres programmes qui se sont glissés là par erreur. Je n'en tiendrai pas
rigueur.

## Contenu de l'archive
	main/PICT1:     picture (double 128x64 image)
	main/PICT2:     picture (double 128x64 image)
	main/PICT3:     picture (double 128x64 image)
	main/PICT4:     picture (double 128x64 image)
	main/PICT5:     picture (double 128x64 image)
	main/PICT6:     picture (double 128x64 image)
	system/111:     program (password: '31415926')
	system/222:     program (password: '31415926')
	system/PH1:     program (password: '31415926')
	system/PH2:     program (password: '31415926')
	system/TABLEAU: program (no password)

## Test
Dès qu'on arrive, déjà, un menu fancy en mode texte avec des noms d'éléments
formant un cadre autour des options à sélectionner ("Cr", "He", "Al", ...).
Il y a quatre options : Tableau, AIDE, CREDITS, QUITTER.
Le curseur est un double-curseur à gauche et à droite de l'option courante,
aucun problème avec celui-ci. Dommage pour le fait qu'on ne puisse pas revenir
en haut en allant plus bas que QUITTER.

L'aide affiche ce texte en mode graphique :

	Le curseur est représenté par ce symbole  --
	La touche EXIT permet un retour au menu principal.
	Il est conseillé d'utiliser la fonction QUITTER du menu pour
	désactiver les backgrounds.

Malheureusement, l'affichage est moche parce que les axes sont présents
en mode graphique chez moi (j'imagine qu'il manque les instructions pour
les désactiver dans le programme). Appuyer sur EXE ou EXIT permet de
revenir au menu principal (même si EXIT passe par un "Done"/"- Disp -").

Les crédits, toujours en mode graphique avec le même problème des axes,
affichent "Programme par CODEBLOCKS pour les 7 days CPC n 21", entouré
par des '#'.

"QUITTER" affiche un cadre de '#' avec "CODEBLOCKS" puis "À bientôt"
Davant de quitter. Je suis du genre à vouloir que quand j'appuie sur
"QUITTER", ça quitte immédiatement (éventuellement avec un EXE à faire
après), mais pourquoi pas.

Enfin, "Tableau" permet d'accéder aux éléments. Il n'y a qu'une partie
des quatres premières lignes, puisque l'écran n'est pas bien grand ;
pour accéder à la suite, il suffit de déplacer le curseur jusqu'à droite
de l'écran puis encore un coup à droite, ou la même chose en bas.

Pour ce que j'en ai vu, le curseur se déplace d'un pixel de trop quand il va
en haut ; couplé au fait qu'il s'agisse d'un caractère, le curseur finit par
abîmer les pixels autour de lui (lettres, bordures), et c'est dommage.
(deux traits auraient sans doute été préférables à l'utilisation d'un caractère)

Une fois sur un élément, il est possible de faire EXE dessus pour afficher
le nom de l'élément, sa catégorie et son numéro atomique (désigné dans
le programme sous le simple nom de "Numéro") dans un écran à part. Il
aurait été intéressant d'afficher d'autres détails, tel que le nombre
de masse, etc - enfin, oui, je sais, une semaine, et tous ces éléments ont
déjà dû être chiants à taper.

Petit bug sur le tableau en lui-même : il semble qu'au bout d'un moment,
faire EXE sur les éléments ne fait que clignoter le curseur et n'affiche
plus les détails sur les éléments. Pour reproduire ce bug, la manoeuvre
que j'ai isolée est d'aller sur un emplacement invalide du premier écran,
switcher à l'écran de droite, puis reswitcher sur l'écran de gauche,
et ça y est. À partir de ce moment-là, faire EXE ne fait plus rien, il
faut quitter le tableau et y revenir (pas besoin de quitter le programme).
Dommage.

En conclusion, quelques bugs (axes, curseur, EXE sur un élément) et un programme
un peu surchargé niveau design, mais pas trop mal.

## Programme
13912 octets, pas de commentaires. Toujours un plaisir, merci d'avoir pensé
aux pauvres correcteurs qui devront se taper la lecture du programme.

De ce que j'en ai compris, les éléments sont hardcodés par rapport à la
position du curseur ; c'est dommage, le calcul du numéro atomique pourrait
être fait avant la liste des éléments (la catégorie serait ainsi calculable,
seul le nom aurait besoin d'être listé, il y a moyen d'alléger le programme
et de le rendre plus maintenable ainsi).

Du reste, pas grand chose à dire, il n'y a pas cent mille façon de faire.

## Attribution des points
- **Qualité du code, absence de bugs : 1,25/3**  
  Quelques bugs (axes, curseur, EXE sur un élément) et les éléments qui auraient
  peut-être pu être hardcodés d'une façon plus économe en place et plus
  maintenable.

- **Vitesse d'exécution, fluidité : 2/2**  
  Pas de soucis de ce côté-là.

- **Interface utilisateur, ergonomie : 1,5/2**  
  Des commandes intuitives, même s'il aurait été utile de trouver un moyen
  d'informer l'utilisateur du fait qu'il y a plusieurs parties dans le tableau
  (la navigation se fait de façon intuitive pour les joueurs, pas forcément
  pour les utilisateurs lambda). Une animation de fin (j'ai déjà dit que
  je n'aimais pas ça ?).

- **Présentation, graphisme : 1,25/2**  
  Une interface plutôt surchargée, et la non-désactivation des axes qui m'a
  pas mal gâché l'expérience.

- **Ressenti général, respect du thème ou bonus : 0,25/1**  
  Le boulot a été fait et c'est correct.

- **NOTE FINALE DU PROGRAMME : 6,25/10**
