# PGCM et PGCD par Dugben
## Consignes
L'objectif donné à Dugben lors de cette édition était "PGCD - PPCM".
Le programme, contenu dans le fichier `Ppcmetpg.g1m`, est donc
`PPCM` (un nom plutôt trompeur : pour la clarté, faire un programme
`PGCD` qui redirige vers le programme `PPCM` aurait été pas mal).

## Contenu de l'archive
	system/PPCM: program (no password)

## Test
Le programme utilise apparemment entièrement le mode console (le mode
le plus simple à utiliser côté développeur, mais pas forcément le plus
esthétique/maniable pour l'utilisateur).

On commence par un "splash screen" avec un "- Disp -" nous indiquant
qu'il faut appuyer sur EXE (il faut connaître, c'est un coup à ne pas
atteindre le public visé).

Arrive ensuite l'instruction "Entrer deux nombre entier" (sic). J'essaie
donc des nombres de base, disons, 9 et 5. Le PPCM est bien 45, le PGCD est
bien 1. Le programme propose : "Refaire oui=1 non=2". Si j'entre 2 (ainsi
que n'importe quel nombre différent de 1), il quitte bien le programme,
autrement, il revient bien à l'étape où je dois entrer deux nombres
entiers. On peut regretter une erreur math lorsque j'entre un nombre
flottant au lieu d'une erreur plus explicite.

Aussi, malgré la consigne, les cas négatifs ne sont pas gérés :
si j'entre -2 et 5, le calcul ne s'arrête jamais alors que le résultat
devrait être 10.

## Programme
332 octets (donc petit programme), et quelques commentaires pour délimiter
les sections du programme. Usage des labels pour les boucles (parce que
While/End c'est so 2000). L'implémentation des algorithmes a l'air basique
mais fonctionnelle (mise à part les bugs décrits au-dessus).

Le programme est simple à comprendre du fait de l'utilisation du mode
console, mais simple tout court. Casser un peu cette simplicité pour
une meilleure interface utilisateur aurait été une bonne idée, m'enfin.

## Attribution des points
- **Qualité du code, absence de bugs : 0,5/3**  
  Du code vraiment basique, pas totalement failproof (PPCM avec au moins un
  nombre négatif, flottant). Un petit commentaire avec une faute dedans
  que je note néanmoins.

- **Vitesse d'exécution, fluidité : 1,5/2**  
  Plutôt rapide dans les cas simples, mais dès qu'on entre dans les quatre
  chiffres, ça devient lent, c'est dommage.

- **Interface utilisateur, ergonomie : 0/2**  
  C'est de la console quoi, y a pas plus basique à faire, et y a clairement
  plus simple pour l'utilisateur...

- **Présentation, graphisme : 0/2**  
  Y a dé fot lol.

- **Ressenti général, respect du thème ou bonus : 0/1**  
  Beaucoup trop pauvre pour mériter un bonus...

- **NOTE FINALE DU PROGRAMME : 2/10**
