# Partique par Neuronix9302
## Consignes
L'objectif donné à Neuronix9302 était de faire un programme
d' "écriture de musique (portée)". Un sujet pas évident que
Neuronix a semble-t-il toutefois décidé de relever.

La description du programme sur Planète Casio est
"Voici ma participation au 7 Days CPC 21", il semble donc que je vais
devoir me débrouiller seul en cas de souci.

## Contenu de l'archive
	$GLOBAL/ALPHAMEM: alpha memory
	$GLOBAL/SETUP:    alpha memory
	system/ -APROP:   program (no password)
	system/ -DRAW:    program (no password)
	system/ -FA:      program (no password)
	system/ -NOTE:    program (no password)
	system/ -QUIT:    program (no password)
	system/ -SOL:     program (no password)
	system/PARTIQ1:   program (no password)

## Test
Une fois dépaqueté, le g1m révèle contenir une myriade de petits programmes
secondaires, néanmoins ceux-ci sont facilement distinguables du programme
principal dû au fait qu'ils sont préfixés par "-". Je lance donc `PARTIQ1`.

Les premiers soucis se situent dans le menu principal. Alors que la première
fois, les axes était cachés, quelques lancements d'après, une fois les éléments
du menu dessinés, les axes réapparaissent (mais pas toujours... ?).
Au niveau des options, les anciennes traces ne semblent malheureusement pas
effacés : quand je déplace le curseur vers l'option d'en-dessous, la flèche
est toujours présente sur l'option d'au-dessus et également sur l'option
courante. De plus, l'effet sympathique de décalage de texte vers la gauche
lorsque l'option est sélectionnée est également ruinée par le fait que les
traces du texte sur son placement d'origine restent... dommage.

Les touches sont peu sensibles, qu'il s'agisse du menu principal ou des
autres menus. Le menu "À propos" explique le but du programme, mais se
termine sur "Ceci est une version pre-" avec une flèche en bas à droite
semblant indiquer qu'il y a une suite. J'ai testé toutes les touches, la
seule action que j'ai eu était un retour au menu principal en relâchant la
touche F6.

Appuyer sur "Exit" affiche une animation "Au revoir" avec les lettres qui
s'effacent puis réapparaissent séquentiellement, attendant qu'on appuie
sur EXE. (j'ai déjà dit ce que je pensais de ce genre d'animations de
sortie dans une autre critique pour les CPC #21)

Bon, à présent, créons une partition. On me demande si je souhaite une
clé de sol ou une clé de fa (1 ou 2), puis "Note dure 1 temps"
(ronde, blanche, noir, croche), le tout pour la portée du haut, puis
la même chose pour la portée du bas, ainsi que le nombre de temps par
mesure, le tout en mode console.

Ensuite, deux partitions (séries de lignes, éventuellement avec une clé
de sol ou de fa si on a bien entré 1 ou 2) s'affichent, avec une note.
On peut déplacer cette note avec les flèches. Mon premier réflexe était
d'utiliser EXE pour poser la note, mais en fait non, il faut utiliser
les touches F1 à F4. F1 sert à poser une note ronde, F2 sert à poser une
blanche, F3 sert à poser une noire, F4 sert à poser une croche. Toutes
les autres touches font avancer le curseur d'un cran. Avec les flèches,
il est possible de ne bouger que de plusieurs crans à la fois, les autres
touches ne font bouger que d'une portion de ce cran.

Je pense avoir exploré à peu près tout ce qui était explorable dans
ce programme. (s'il y a d'autre features, elles n'avaient qu'à être
documentées.)

## Programme
Aucun commentaire, mais des sous-programmes (y a pas plus clair comme
division).

De ce que j'en ai compris, `PARTIQ1` contient le menu principal, le
dessin de la partition de base, les questions en mode console et les
appels aux autres programmes, ` -SOL` et ` -FA` sont les dessins des
clés, ` -NOTE` contient les dessins de notes, ` -APROP` est appelé
pour afficher l'à propos (j'ai d'ailleurs pu découvrir qu'il y avait
le symbole "beta" après le "pre-", qui ne s'affiche apparemment pas
(désolé de casser ainsi le suspens :D)), ` -QUIT` contient les
animations lorsque l'utilisateur quitte, et ` -DRAW` contient l'interface
de dessin des notes. Les programmes font tous en-dessous de mille
octets, ce qui fait qu'ils sont plutôt lisibles.

Autrement, c'est du Basic avec beaucoup d'usage du graphique, donc
bon, rien de bien exceptionnel.

## Attribution des points
- **Qualité du code, absence de bugs : 2/3**  
  Un menu principal buggué, pas de commentaires, mais un code compartimenté
  correctement.

- **Vitesse d'exécution, fluidité : 2/2**  
  Nul besoin de s'attarder dans cette section.

- **Interface utilisateur, ergonomie : 1,25/2**  
  Une alternance console basique/mode graphique un peu déstabilisante.
  Le choix des touches fonctions pour poser des notes n'est pas super intuitif,
  il aurait fallu en parler quelque part.
  Une manière de sauvegarder/charger des partitions n'aurait pas été de trop.

- **Présentation, graphisme : 1,5/2**  
  Les axes et les bugs graphiques m'ont un peu gâché cet aspect-là, mais
  sinon, c'est pas trop mal.

- **Ressenti général, respect du thème ou bonus : 0,5/1**  
  Comme dit le docteur Castafolte, "c'est une beta", mais ce n'est pas un
  sujet facile.

- **NOTE FINALE DU PROGRAMME : 7,25/10**
